您的位置:首页 > 其它

hdu 1969 Pie (二分法+贪心)

2016-05-22 20:30 459 查看

Pie

[b]Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 8697    Accepted Submission(s): 3182
[/b]

[align=left]Problem Description[/align]
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This
should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is
better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

 

[align=left]Input[/align]
One line with a positive integer: the number of test cases. Then for each test case:

---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.

---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.

 

[align=left]Output[/align]
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
 

[align=left]Sample Input[/align]

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

 

[align=left]Sample Output[/align]

25.1327
3.1416
50.2655

解题思路:最开始做这道题确实没什么思路,浮点数还要最大值,后来才知道这种题目要用二分法来做,也是第一次做二分法的题目。每次从一个区间内取中间值进行判断,如果中间值可以满足条件说明最大值还能更大,如果不满足,最大值小于这个中间值,不过要注意一下精度,最好写到e-5,我写e-4WA了==

#include <iostream>
#include <cstdio>
#include <cmath>
#define PI acos(-1.0)

using namespace std;

double S[10011];

int main()
{
int T;
int n,num;
int i;
int temp;
double low,up,mid;

scanf("%d",&T);

while(T--)
{
scanf("%d%d",&n,&num);
num++;
up=0;
for(i=0;i<n;i++)
{
scanf("%d",&temp);
S[i]=PI*temp*temp;
up=max(up,S[i]);
}
low=0;
mid=(low+up)/2;
while(up-low>0.00001)
{
temp = 0;
for(i=0;i<n;i++)
{
temp += int(S[i]/mid);
}
if(temp>=num) low = mid;
else up = mid;
mid = (up+low)/2;
}
printf("%0.4lf\n",mid);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: